%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                          %
% Nearest Neighbor klassifikator for K=1. Finner nrmeste nabopunkter      %
% for ett sett uklassifiserte vektorer                                     %
%                                                                          % 
% Anders Torsteinb, NTNU 2007.                                            % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
clc;

K1True=0;
K1False=0;
K0True=0;
K0False=0;

%Last inn Refleksjonskoeffisient sett Rref og Rtren (Referanse og Trening)
%1. rad i variablene angir om de tilhrer klasse 0 eller klasse 1
load('ReflK.mat')



[O,antT]=size(Rtren);
[O,antR]=size(Rref);





n=43+1;                      %antall ordener av refleksjonskoeffisientene som skal tas med

for j=1:antT                   %Tester ett og ett treningssett
    for k=1:antR               %mot n antall referansesett for  finne ut hvilket som er nrmest
        
        d(k) = norm(Rtren(2:n,j) - Rref(2:n,k) );   %Beregner euklidsk lengde mellom vektorene
        
    
    end
    [a(j) b(j)]=min(d);        %finner minste forskjell d, og returner b, som angir plasseringen hvilket treningsett som referansesettet er nrmest
    
    c=Rref(1,b(j));        %finner ut hvilken klasse referansesettet Rtren(1,b) tilhrer
    e=Rtren(1,j);            %finner ut hvilken klasse treningsesettet Rtren(1,k) tilhrer
   
   %Fyller inn antall treff og bom som klassifikatoren gjr
    if e==1
        if c==e
            K1True=K1True+1;
        else
            K1False=K1False+1;
        end
    else
       if c==e
           K0True=K0True+1;
       else
           K0False=K0False+1;
       end
    end
           
    
end
