%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                          %
% Nearest Neighbor klassifikator for K=3. Finner nrmeste nabopunkter      %
% for ett sett uklassifiserte vektorer                                     %
%                                                                          % 
% Anders Torsteinb, NTNU 2007.                                            % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
clc;

K1True=0;
K1False=0;
K0True=0;
K0False=0;

%Last inn Refleksjonskoeffisient sett Rref og Rtren (Referanse og Trening)
%1. rad i variablene angir om de tilhrer klasse 0 eller klasse 1
load('ReflK.mat')



[O,antT]=size(Rtren);
[O,antR]=size(Rref);





n=16+1;                   %antall ordener av refleksjonskoeffisientene som skal tas med

for k=1:antT                   %Tester ett og ett referansesett
    for j=1:antR               %mot n antall treningssett for  finne ut hvilket det er nrmest
        
       d(j) = norm(Rtren(2:n,k) - Rref(2:n,j) );    %Beregner euklidsk lengde av hver vektor, og finner differansen mellom de.
          
    end
    [a1 b1(k)]=min(d);        %returner b, som angir plasseringen hvilket treningsett som referansesettet er nrmest
    d(b1(k))=max(d);
    [a2 b2(k)]=min(d);         %finner k2 minimum avstand
    d(b2(k))=max(d);
    [a3 b3(k)]=min(d);         %finner k3 minimum avstand
    
    c1=Rref(1,b1(k));        %finner ut hvilken klasse treningsettet Rref(1,b) tilhrer for de tre minste d
    c2=Rref(1,b2(k)); 
    c3=Rref(1,b3(k)); 
    e=Rtren(1,k);           %finner ut hvilken klasse treningssesettet Rtren(1,k) tilhrer
   
      %Fyller inn antall treff og bom som klassifikatoren gjr
    if e==1
        if ((c1==e)&(c2==e)&(c3==e)) | ((c1==e)&(c2==e)) | ((c2==e)&(c3==e)) | ((c1==e)&(c3==e))
            K1True=K1True+1;
        else
            K1False=K1False+1;
        end
    else
       if ((c1==e)&(c2==e)&(c3==e)) | ((c1==e)&(c2==e)) | ((c2==e)&(c3==e)) | ((c1==e)&(c3==e))
           K0True=K0True+1;
       else
           K0False=K0False+1;
       end
    end
           
    
end